#!/bin/env python
#*************************************************************************************************
#                          geurocalc.py  -  description                                          *
#                             -------------------                                                *
#    begin                : 01 dec 2002                                                          *
#    last modif           : 03 september 2003                                                    *
#    copyright            : (C) 2003 by Jean-Baptiste Renard                                     *
#    email                : renardjb@free.fr                                                     *
#*************************************************************************************************/

#**************************************************************************************************
#*                                                                                                *
#*   This program is free software; you can redistribute it and/or modify it under the terms of   *
#*   the GNU General Public License as published by                                               *
#*   the Free Software Foundation; either version 2 of the License, or                            *
#*   (at your option) any later version.                                                          *
#*                                                                                                *
#**************************************************************************************************/
import locale
from math import *
from re import sub

from gtk import *

geurocalc_xpm = [
"47 48 707 2",
"      c None",
".     c #E0DCCF",
"+     c #D8D4C9",
"@     c #D0CBBF",
"#     c #BFBAAD",
"$     c #D6D1C5",
"%     c #E7E3D8",
"&     c #E3E0D5",
"*     c #E1DDD3",
"=     c #DEDACF",
"-     c #DAD6CA",
";     c #D7D3C7",
">     c #D3CEC1",
",     c #C2BEB0",
"'     c #C1BDB0",
")     c #B6B2A5",
"!     c #E2DDD0",
"~     c #E4E0D5",
"{     c #91988C",
"]     c #294938",
"^     c #627566",
"/     c #7B8A7C",
"(     c #9DA398",
"_     c #AEB1A7",
":     c #D7D3C8",
"<     c #D4D0C4",
"[     c #D0CCC0",
"}     c #CCC8BC",
"|     c #C9C6B9",
"1     c #C1BDB1",
"2     c #B7B2A6",
"3     c #AEAA9E",
"4     c #D7D2C5",
"5     c #E5E0D4",
"6     c #C6C7B9",
"7     c #3F5B4B",
"8     c #4E6C59",
"9     c #65816D",
"0     c #5E7A67",
"a     c #536E5C",
"b     c #4C6656",
"c     c #465F50",
"d     c #516758",
"e     c #69776B",
"f     c #868E83",
"g     c #92978B",
"h     c #B7B4A9",
"i     c #C7C3B8",
"j     c #C3BFB4",
"k     c #C2BEB2",
"l     c #C0BCB1",
"m     c #BDB9AD",
"n     c #B1AEA3",
"o     c #A8A59A",
"p     c #939086",
"q     c #A8A498",
"r     c #E1DCCE",
"s     c #5E7263",
"t     c #4B6B59",
"u     c #6D8A77",
"v     c #708D7A",
"w     c #6E8976",
"x     c #6B8572",
"y     c #698370",
"z     c #677F6D",
"A     c #627868",
"B     c #59705F",
"C     c #516657",
"D     c #4A5E50",
"E     c #435648",
"F     c #405246",
"G     c #536156",
"H     c #5D675D",
"I     c #888B81",
"J     c #888C82",
"K     c #BEBAAF",
"L     c #BCB9AE",
"M     c #B4B0A4",
"N     c #858279",
"O     c #63615B",
"P     c #D4D0C2",
"Q     c #E4E0D4",
"R     c #DFDBCE",
"S     c #C1C0B2",
"T     c #A9B0A2",
"U     c #A0AFA0",
"V     c #96A898",
"W     c #748F7E",
"X     c #738D7D",
"Y     c #718A7B",
"Z     c #6F8777",
"`     c #6B8272",
" .    c #697E6E",
"..    c #667A69",
"+.    c #647768",
"@.    c #627465",
"#.    c #5B6D5E",
"$.    c #546457",
"%.    c #4D5C50",
"&.    c #455448",
"*.    c #46544A",
"=.    c #515E55",
"-.    c #B0ABA0",
";.    c #7B7870",
">.    c #5E5C55",
",.    c #B2AEA2",
"'.    c #E0DBCE",
").    c #E5E2D9",
"!.    c #D6D1C3",
"~.    c #D1CCBE",
"{.    c #D0CBBD",
"].    c #CEC9BB",
"^.    c #CCC7BA",
"/.    c #C1C0B3",
"(.    c #B0B5A8",
"_.    c #92A093",
":.    c #879889",
"<.    c #708778",
"[.    c #6F8476",
"}.    c #6D8173",
"|.    c #6A7C6F",
"1.    c #67786A",
"2.    c #647466",
"3.    c #617063",
"4.    c #5E6C5F",
"5.    c #636F64",
"6.    c #6A776E",
"7.    c #B1ADA1",
"8.    c #ACA89C",
"9.    c #74716A",
"0.    c #595650",
"a.    c #DDD8CB",
"b.    c #E3DFD3",
"c.    c #EDEBE4",
"d.    c #DCDBD9",
"e.    c #73726E",
"f.    c #908F88",
"g.    c #A19E94",
"h.    c #C0BBAF",
"i.    c #C9C4B7",
"j.    c #C7C3B5",
"k.    c #C5C1B4",
"l.    c #C4BFB2",
"m.    c #C2BDB0",
"n.    c #B1B2A6",
"o.    c #A7AC9F",
"p.    c #8D988C",
"q.    c #79877D",
"r.    c #6E7D72",
"s.    c #6B7B6F",
"t.    c #69776C",
"u.    c #727E75",
"v.    c #A8A499",
"w.    c #716F67",
"x.    c #53514C",
"y.    c #B4AFA4",
"z.    c #E1DDD0",
"A.    c #E4E0D6",
"B.    c #EDEBE6",
"C.    c #BEC2B8",
"D.    c #92A199",
"E.    c #939E97",
"F.    c #747570",
"G.    c #8B8A86",
"H.    c #989690",
"I.    c #928F87",
"J.    c #9F9C93",
"K.    c #ACA89E",
"L.    c #BAB7AB",
"M.    c #C0BCAF",
"N.    c #BDB8AC",
"O.    c #BBB6AA",
"P.    c #B9B5A8",
"Q.    c #B7B3A7",
"R.    c #A1A399",
"S.    c #989B90",
"T.    c #899187",
"U.    c #7B867E",
"V.    c #A39F94",
"W.    c #6F6C64",
"X.    c #514F49",
"Y.    c #DEDACD",
"Z.    c #E2DED2",
"`.    c #EFEEE9",
" +    c #CACAC4",
".+    c #849089",
"++    c #6F8783",
"@+    c #718681",
"#+    c #6F736E",
"$+    c #EFEEEA",
"%+    c #CECABE",
"&+    c #BEBAAE",
"*+    c #AAA69C",
"=+    c #838078",
"-+    c #8F8F8D",
";+    c #85827C",
">+    c #8E8B83",
",+    c #97958B",
"'+    c #A3A096",
")+    c #B0ACA1",
"!+    c #B3B0A3",
"~+    c #B3AFA3",
"{+    c #B0ACA0",
"]+    c #AFAA9F",
"^+    c #ADA99D",
"/+    c #9E9A8F",
"(+    c #6B6861",
"_+    c #4E4C47",
":+    c #010101",
"<+    c #E2DFD4",
"[+    c #EBEAE6",
"}+    c #80847D",
"|+    c #606B66",
"1+    c #4A5754",
"2+    c #414946",
"3+    c #848482",
"4+    c #BAB8B0",
"5+    c #C1BCB0",
"6+    c #C5C0B3",
"7+    c #C3BEB1",
"8+    c #6A6966",
"9+    c #D8D7D2",
"0+    c #AFAB9F",
"a+    c #9E9B92",
"b+    c #978642",
"c+    c #A8923B",
"d+    c #D2B22F",
"e+    c #D7B632",
"f+    c #DCBB36",
"g+    c #E2C03B",
"h+    c #C8B56C",
"i+    c #B4AB8C",
"j+    c #97948A",
"k+    c #69665F",
"l+    c #484641",
"m+    c #020201",
"n+    c #DFDBCF",
"o+    c #F3F3F0",
"p+    c #D2D4CD",
"q+    c #9EA9A0",
"r+    c #889993",
"s+    c #7D8E88",
"t+    c #656C65",
"u+    c #C0C0C0",
"v+    c #8D8981",
"w+    c #78766D",
"x+    c #76746C",
"y+    c #68655E",
"z+    c #72716F",
"A+    c #B5B2AA",
"B+    c #C3BA99",
"C+    c #E0C352",
"D+    c #FDE00B",
"E+    c #FDDE0B",
"F+    c #FDDC0B",
"G+    c #FCD90B",
"H+    c #FCD70B",
"I+    c #FCD50B",
"J+    c #FCD30B",
"K+    c #FBD10B",
"L+    c #FBCF0B",
"M+    c #E3C625",
"N+    c #867A4A",
"O+    c #353430",
"P+    c #CAC6B9",
"Q+    c #E1DDD1",
"R+    c #E8E5DD",
"S+    c #F0F0ED",
"T+    c #9EA59C",
"U+    c #8A9790",
"V+    c #879992",
"W+    c #707B75",
"X+    c #A6A8A4",
"Y+    c #DFDED8",
"Z+    c #C6C1B4",
"`+    c #6B6962",
" @    c #AAAAAA",
".@    c #B39B41",
"+@    c #FDE30B",
"@@    c #FDE10B",
"#@    c #FDDF0B",
"$@    c #FDDD0B",
"%@    c #FCDA0B",
"&@    c #FCD80B",
"*@    c #FCD60B",
"=@    c #FCD40B",
"-@    c #FCD20B",
";@    c #FBD00B",
">@    c #FBCD0B",
",@    c #FBCB0B",
"'@    c #FBC90B",
")@    c #665926",
"!@    c #020202",
"~@    c #DED9CD",
"{@    c #E2DFD2",
"]@    c #EEECE8",
"^@    c #BFC3BA",
"/@    c #7D8780",
"(@    c #5C6662",
"_@    c #535E59",
":@    c #484D49",
"<@    c #CFCFCF",
"[@    c #BEB9AE",
"}@    c #C4C0B2",
"|@    c #C2BEB1",
"1@    c #686661",
"2@    c #F9D856",
"3@    c #FEE40B",
"4@    c #FDE20B",
"5@    c #EACB13",
"6@    c #CCAC29",
"7@    c #857734",
"8@    c #8D823E",
"9@    c #9A8E4A",
"0@    c #A79239",
"a@    c #CFAE2A",
"b@    c #FBCC0B",
"c@    c #FBCA0B",
"d@    c #E8BB13",
"e@    c #33332F",
"f@    c #000000",
"g@    c #D4CFC1",
"h@    c #E0DBCF",
"i@    c #E7E5DD",
"j@    c #EAEAE6",
"k@    c #A3ADA3",
"l@    c #8D9D96",
"m@    c #80938D",
"n@    c #65716D",
"o@    c #757774",
"p@    c #A09F9B",
"q@    c #78756D",
"r@    c #838077",
"s@    c #858178",
"t@    c #7A786F",
"u@    c #DBBA38",
"v@    c #FEE50B",
"w@    c #F4D91C",
"x@    c #A5934D",
"y@    c #8E8E8C",
"z@    c #ADA99F",
"A@    c #A5A59A",
"B@    c #8D8E85",
"C@    c #787971",
"D@    c #40403C",
"E@    c #75726B",
"F@    c #AEA586",
"G@    c #DFBF21",
"H@    c #A28B32",
"I@    c #33322F",
"J@    c #010100",
"K@    c #A39F95",
"L@    c #DDD8CC",
"M@    c #EDEBE7",
"N@    c #C2C5BE",
"O@    c #92A098",
"P@    c #80948E",
"Q@    c #7A908A",
"R@    c #5B645F",
"S@    c #D6D6D3",
"T@    c #CEC9C0",
"U@    c #C3BFB1",
"V@    c #AFABA0",
"W@    c #AAA69A",
"X@    c #BB9F31",
"Y@    c #FEE60B",
"Z@    c #FDE40B",
"`@    c #D7B631",
" #    c #9F9B90",
".#    c #716F69",
"+#    c #9D9C99",
"@#    c #ADA99E",
"##    c #ABA79C",
"$#    c #A9A599",
"%#    c #76736B",
"&#    c #A4A095",
"*#    c #57544F",
"=#    c #171615",
"-#    c #D2CEC1",
";#    c #E7E4DC",
">#    c #E9EAE6",
",#    c #616963",
"'#    c #596561",
")#    c #5C6D69",
"!#    c #586661",
"~#    c #656865",
"{#    c #E2E1DD",
"]#    c #C2B581",
"^#    c #FEE70B",
"/#    c #DFBD38",
"(#    c #88857C",
"_#    c #31312F",
":#    c #757470",
"<#    c #979489",
"[#    c #AAA69B",
"}#    c #7D7A72",
"|#    c #7C7971",
"1#    c #A19D92",
"2#    c #716E67",
"3#    c #56534E",
"4#    c #020101",
"5#    c #A29E94",
"6#    c #DCD8CB",
"7#    c #F4F3F1",
"8#    c #B1B8AF",
"9#    c #8A9A93",
"0#    c #71837F",
"a#    c #63746F",
"b#    c #49504C",
"c#    c #8C8C89",
"d#    c #6A6863",
"e#    c #918E84",
"f#    c #A7A498",
"g#    c #F0DC17",
"h#    c #F5DC1C",
"i#    c #B5B1A5",
"j#    c #B4AFA3",
"k#    c #5B5B58",
"l#    c #B9B7B1",
"m#    c #827F76",
"n#    c #6C6962",
"o#    c #56544E",
"p#    c #6A6760",
"q#    c #4F4D48",
"r#    c #8F8C82",
"s#    c #9E9B90",
"t#    c #6D6A62",
"u#    c #52504A",
"v#    c #EBE8E2",
"w#    c #E7E7E3",
"x#    c #96A39B",
"y#    c #7E928D",
"z#    c #7C918B",
"A#    c #707E79",
"B#    c #757873",
"C#    c #E7E6E1",
"D#    c #AAA59A",
"E#    c #908C83",
"F#    c #B39C42",
"G#    c #B4A673",
"H#    c #817E75",
"I#    c #797876",
"J#    c #C4C1B8",
"K#    c #ABA79B",
"L#    c #A9A59A",
"M#    c #A7A398",
"N#    c #4F4D47",
"O#    c #8E8B81",
"P#    c #9A978C",
"Q#    c #696660",
"R#    c #4F4E48",
"S#    c #E0DCD2",
"T#    c #F0F0F0",
"U#    c #A5A69C",
"V#    c #8B9790",
"W#    c #849690",
"X#    c #889992",
"Y#    c #747A74",
"Z#    c #BDBDB9",
"`#    c #DAD6CE",
" $    c #BFBBAE",
".$    c #BDB9AC",
"+$    c #E8D229",
"@$    c #CAAD3E",
"#$    c #726F68",
"$$    c #5B5852",
"%$    c #5A5852",
"&$    c #888786",
"*$    c #AFACA1",
"=$    c #A6A297",
"-$    c #66645D",
";$    c #8D8A80",
">$    c #969388",
",$    c #66635D",
"'$    c #4C4944",
")$    c #DBD6C9",
"!$    c #E5E2DA",
"~$    c #B7B4AE",
"{$    c #86867D",
"]$    c #70746D",
"^$    c #626862",
"/$    c #7E827B",
"($    c #696A64",
"_$    c #E1E0DC",
":$    c #C4C0B4",
"<$    c #D5C178",
"[$    c #FEEB0B",
"}$    c #FEE90B",
"|$    c #EABC14",
"1$    c #8A867E",
"2$    c #8D8980",
"3$    c #5D5B55",
"4$    c #3E3D39",
"5$    c #ACA89D",
"6$    c #DEDACE",
"7$    c #D9D5CA",
"8$    c #D0CBBE",
"9$    c #CDC8BA",
"0$    c #C7C3B6",
"a$    c #C0BEB2",
"b$    c #ABAB9F",
"c$    c #96958B",
"d$    c #88857D",
"e$    c #7C7A73",
"f$    c #74726A",
"g$    c #B8A045",
"h$    c #FEEA0B",
"i$    c #FEE80B",
"j$    c #FDDB0B",
"k$    c #A68A1D",
"l$    c #949187",
"m$    c #7D7971",
"n$    c #4E4D47",
"o$    c #31302D",
"p$    c #CBC6B9",
"q$    c #D5D0C4",
"r$    c #D1CCBF",
"s$    c #CBC7B9",
"t$    c #CAC5B7",
"u$    c #C7C2B5",
"v$    c #C4C0B3",
"w$    c #C0BDB0",
"x$    c #BDAF7C",
"y$    c #B9A65E",
"z$    c #D5B32F",
"A$    c #DFC520",
"B$    c #A99750",
"C$    c #BCA962",
"D$    c #C9B66D",
"E$    c #B8A55E",
"F$    c #8F7E3B",
"G$    c #E6D490",
"H$    c #DAC883",
"I$    c #DDCB87",
"J$    c #DBC984",
"K$    c #D3C27C",
"L$    c #C3B26C",
"M$    c #585239",
"N$    c #615F57",
"O$    c #3A3835",
"P$    c #252421",
"Q$    c #A7A499",
"R$    c #C0BCB0",
"S$    c #C1BCAF",
"T$    c #BBB7AA",
"U$    c #BAB5A9",
"V$    c #E7C53F",
"W$    c #C8B155",
"X$    c #6F6C65",
"Y$    c #585650",
"Z$    c #64625B",
"`$    c #777572",
" %    c #9F9D99",
".%    c #A3A19A",
"+%    c #BDBAB3",
"@%    c #B8B6B1",
"#%    c #ACAAA6",
"$%    c #95948E",
"%%    c #3D3C39",
"&%    c #615F59",
"*%    c #43413C",
"=%    c #282725",
"-%    c #1D1C1A",
";%    c #605E58",
">%    c #716E66",
",%    c #75726A",
"'%    c #949186",
")%    c #959288",
"!%    c #98958A",
"~%    c #9C988D",
"{%    c #A09D92",
"]%    c #B0AB9F",
"^%    c #BEB594",
"/%    c #CEBB72",
"(%    c #ECD22C",
"_%    c #DCBF4E",
":%    c #C9B66E",
"<%    c #C8B56D",
"[%    c #C7B46C",
"}%    c #AF9C57",
"|%    c #AD9A56",
"1%    c #9A8843",
"2%    c #897734",
"3%    c #92803E",
"4%    c #8F7E3A",
"5%    c #292826",
"6%    c #484741",
"7%    c #34322F",
"8%    c #22221F",
"9%    c #161514",
"0%    c #0B0A09",
"a%    c #090808",
"b%    c #060606",
"c%    c #1A1918",
"d%    c #3E3E39",
"e%    c #88847B",
"f%    c #8B887E",
"g%    c #8F8C83",
"h%    c #B7A45C",
"i%    c #FCD10B",
"j%    c #FAC60B",
"k%    c #CBA411",
"l%    c #22211E",
"m%    c #3A3834",
"n%    c #292926",
"o%    c #090908",
"p%    c #070706",
"q%    c #060505",
"r%    c #050404",
"s%    c #040303",
"t%    c #030302",
"u%    c #3A3935",
"v%    c #615F58",
"w%    c #BEA232",
"x%    c #FBCE0B",
"y%    c #FAC70B",
"z%    c #FAC50B",
"A%    c #927C24",
"B%    c #474640",
"C%    c #52514B",
"D%    c #413F3B",
"E%    c #302F2B",
"F%    c #191917",
"G%    c #080808",
"H%    c #070707",
"I%    c #050504",
"J%    c #040404",
"K%    c #030303",
"L%    c #BA9813",
"M%    c #998741",
"N%    c #7B7970",
"O%    c #79766E",
"P%    c #78756C",
"Q%    c #484742",
"R%    c #403E3A",
"S%    c #4A4843",
"T%    c #514F4A",
"U%    c #3C3B37",
"V%    c #2F2E2B",
"W%    c #181716",
"X%    c #050505",
"Y%    c #040403",
"Z%    c #987A07",
"`%    c #947807",
" &    c #23211F",
".&    c #312F2C",
"+&    c #4C4A45",
"@&    c #4E4C46",
"#&    c #33322E",
"$&    c #373531",
"%&    c #44433D",
"&&    c #4A4943",
"*&    c #3B3936",
"=&    c #302E2B",
"-&    c #121211",
";&    c #675305",
">&    c #E4C30A",
",&    c #141412",
"'&    c #1E1D1B",
")&    c #32312E",
"!&    c #45443F",
"~&    c #4F4C47",
"{&    c #524F4A",
"]&    c #403E39",
"^&    c #393834",
"/&    c #030202",
"(&    c #463903",
"_&    c #2A2925",
":&    c #363531",
"<&    c #3F3F3A",
"[&    c #43413D",
"}&    c #C8A209",
"|&    c #E8C20A",
"1&    c #261F01",
"2&    c #010000",
"3&    c #E8C00A",
"4&    c #251E01",
"5&    c #655204",
"6&    c #AF8D08",
"7&    c #9A7D07",
"8&    c #5E4C04",
"9&    c #493B03",
"0&    c #896E06",
"a&    c #E4AB0A",
"b&    c #866C06",
"c&    c #DDB20A",
"d&    c #FAC40B",
"e&    c #FAC20B",
"f&    c #FAC00B",
"g&    c #F9BE0B",
"h&    c #F9BC0B",
"i&    c #F9B90B",
"j&    c #A18207",
"k&    c #EFC20A",
"l&    c #FBC80B",
"m&    c #FAC30B",
"n&    c #FAC10B",
"o&    c #FABF0B",
"p&    c #F9BD0B",
"q&    c #F9BA0B",
"r&    c #F9B80B",
"s&    c #927606",
"t&    c #CDA509",
"u&    c #E9B70A",
"v&    c #D2A008",
"w&    c #C39D09",
"x&    c #765F05",
"                                                                                              ",
"                                                                                              ",
"                                                                                              ",
"                                                                                              ",
"                                                                                              ",
"                                                                                              ",
"                                                                                              ",
"                                                                                              ",
"                                  . + @ #                                                     ",
"                                $ % & * = - ; > , '                                           ",
"                              ) ! ~ { ] ^ / ( _ : < [ } | 1 2 3                               ",
"                              4 5 6 7 8 9 0 a b c d e f g h i j k l m n o p                   ",
"                            q r ~ s t u v w x y z A B C D E F G H I J K L M N O               ",
"                            P Q R S T U V W X Y Z `  ...+.@.#.$.%.&.*.=.M -.;.>.              ",
"                          ,.'.~ ).!.~.{.].^./.(._.:.<.[.}.|.1.2.3.4.5.6.7.8.9.0.              ",
"                          a.b.c.d.e.f.g.7.h.i.j.k.l.m.n.o.p.q.r.s.t.t.u.-.v.w.x.              ",
"                        y.z.A.B.C.D.E.F.G.H.I.J.K.L.M.# N.O.P.Q.R.S.T.U.3 V.W.X.              ",
"                        Y.Z.`. +.+++@+#+$+%+&+*+=+-+;+>+,+'+)+!+~+,.{+]+^+/+(+_+:+            ",
"                      ' Z.<+[+}+|+1+2+3+4+5+6+7+8+9+0+K.a+b+c+d+e+f+g+h+i+j+k+l+m+            ",
"                      n+z.o+p+q+r+s+t+u+v+w+x+y+z+A+B+C+D+E+F+G+H+I+J+K+L+M+N+O+:+            ",
"                    P+Q+R+S+T+U+V+W+X+Y+Z+l.m.`+ @.@+@@@#@$@%@&@*@=@-@;@>@,@'@)@!@            ",
"                    ~@{@]@^@/@(@_@:@<@[@}@|@O.1@2@3@4@D+E+5@6@7@8@9@0@a@b@c@d@e@m+f@          ",
"                  g@h@i@j@k@l@m@n@o@p@q@r@s@t@u@v@+@@@w@x@y@z@A@B@C@D@E@F@G@H@I@!@J@          ",
"                K@L@~@M@N@O@P@Q@R@S@T@U@V@W@X@Y@Z@4@`@ #.#+#0+@###$#y+%#&#q@*#=#m+J@          ",
"                -#~@;#>#,#'#)#!#~#{#7+m.h.]#^#v@+@/#(#w._#:#r@<#[#v.}#|#1#2#3#!@4#f@          ",
"              5#6#6#7#8#9#0#a#b#c#d#;.e#f#g#Y@Z@h#i#j#&#k#l#m#n#o#p#q#r#s#t#u#!@:+f@          ",
"              > ~@v#w#x#y#z#A#B#C#|@D#E#F#^#v@+@G#M ,.H#I#J#K#L#M#e#N#O#P#Q#R#f@f@f@          ",
"            V@~@S#T#U#V#W#X#Y#Z#`#'  $.$+$Y@Z@@$#$$$|#%$&$*$L#q =$&#-$;$>$,$'$f@f@f@f@f@f@    ",
"            )$n+!$~${$]$^$/$($_$:$<$[$}$^#v@4@D+E+F+%@H+I+J+K+L+b@c@|$1$2$3$4$f@f@f@f@f@f@    ",
"          5$6$7$8$9$0$a$b$c$d$e$f$g$h$i$Y@+@@@#@$@j$&@*@=@-@;@>@,@'@k$l$m$n$o$f@f@f@f@f@      ",
"          p$q$r$^.s$t$u$v$' w$M.# x$y$z$3@4@A$B$C$D$E$F$G$H$I$J$K$L$M$H#N$O$P$f@f@f@f@f@      ",
"        1#&#Q$v.8.M O. $R$m.S$ $.$T$U$V$+@@@W$r@X$Y$Z$`$ %.%+%@%#%$%%%&%*%=%-%f@f@f@f@f@      ",
"          ;%>%,%r#'%)%!%~%{%f#]%y.^%/%(%4@D+_%:%<%[%y$}%|%1%2%F$3%4%5%6%7%8%9%f@f@f@f@f@f@    ",
"            0%a%b%c%d%%$y+e%(#f%g%h%v@+@@@#@F+%@&@*@=@i%L+>@,@'@j%k%l%l+m%n%9%f@f@f@f@f@f@    ",
"            0%o%p%q%r%s%t%!@=#u%v%w%Z@4@#@$@j$G+H+I+-@;@x%b@c@y%z%A%B%C%D%E%F%f@f@f@f@f@      ",
"              G%H%q%I%J%s%K%K%t%!@m+f@L%E+F+M%q@N%O%P%w.Z$o#Q%4$u%R%S%T%U%V%W%f@f@f@f@        ",
"                  q%X%I%J%J%Y%s%K%4#!@Z%$@j$`%:+ &.&+&@&D%O+#&$&U%%&&&N#*&=&-&f@f@f@f@        ",
"                      J%K%K%K%K%K%!@!@;&F+%@>&m+f@f@f@f@f@,&'&)&!&~&{&C%]&^&f@f@f@f@f@        ",
"                              /&!@:+:+!@j$&@*@(&f@f@J@f@f@f@f@f@f@f@_&:&<&[&f@f@f@f@          ",
"                                      :+}&H+I+|&1&2&f@f@f@f@f@f@f@f@f@f@J@f@f@f@f@            ",
"                                          *@=@-@3&4&f@f@f@f@f@f@2&2&5&f@2&f@f@f@              ",
"                                          6&J+K+x%b@7&8&f@f@f@9&0&a&b&f@f@f@f@f@              ",
"                                            c&L+>@,@'@y%d&e&f&g&h&i&9&f@f@f@f@                ",
"                                              j&k&c@l&z%m&n&o&p&q&r&f@f@f@                    ",
"                                                  s&t&u&e&f&g&v&w&x&f@                        ",
"                                                                                              ",
"                                                                                              ",
"                                                                                              "];
class CalcEngine:
    """ CalcEngine is base object for manipulate and calculate exchange rates
    """
    def __init__( self ):
        # self.dot containts decimal symbol
        locale.setlocale( locale.LC_ALL, '')
        self.dot = locale.localeconv() ['decimal_point']
        # init exchange rates
        self.taux = {'EUR':1.0,'FRF':6.55957,'ATS':13.7603,'BEF':40.3399,'DEM':1.95583,'ESP':166.386,
                  'FIM':5.94573,'IEP':0.787564,'ITL':1936.27,'LUF':40.3399,'PTE':200.482}
        self.set_coef( 'EUR', 'FRF')
        self.value1 = 1.0 
        self.value2 = 0.0
        
    def set_val( self, str_to_evaluate, num):
          """ internal: 
                  str_to_evaluate: the string to evaluate, if str_to_evaluate containing ; an error occurs
                  num: '1' or '2' is the target of the value of str_to_evaluate
              all local decimal point will be replace by '.'
              
          """
          code = str_to_evaluate.replace( ';','ERREUR')
          if self.dot != '.':
              code = code.replace( self.dot,'.')
          else:
                code = str_to_evaluate            
          code = sub( '(?P<b>[^-\.\(\d+]\d+)', '\g<b>.', code )
          code = code.replace( '..', '.')
		  #print code
          code = "self.value" + num + "=" + code
          exec( code)
          
    def set_coef( self, l1, l2 ):
        """ internal: calculate self.coef=l1/l2 """
        self.coef = float( self.taux[l1] ) / float( self.taux[l2] )

    def set_1_to_2( self ):
        """ internal: caculate second entry's value """
        self.value2 = float( self.value1 ) / float( self.coef )
        

    def set_2_to_1( self ):
        """ internal: caculate first entry's value """
        self.value1 = self.value2 * self.coef

class EuroCalc( VBox ):
    """ Eurocalculator
        a box which containds 
    """
    def load_config( self):
        self.txt_euro = 'EUR'
        self.txt_fr = 'FRF'
        try:
            fd = open( os.environ['HOME']+'/.geurocalc','r')
            self.txt_euro = fd.readline()[4:-1]
            self.txt_fr = fd.readline()[4:-1]
            fd.close()
        except:
            self.txt_euro = 'EUR'
            self.txt_fr = 'FRF'
    def save_config( self):
        try:
            fd = open(os.environ['HOME']+'/.geurocalc','w+')
            fd.write( 'TOP='+win.calc_widget.txt_euro + '\n' )
            fd.write( 'BOT='+win.calc_widget.txt_fr + '\n' )
            fd.close()
        except:
            print 'a probleme occur during saving conf'
    def __init__( self):
        VBox.__init__( self)
        
        self.load_config()
        self.calc = CalcEngine( )
        self.set_border_width( 5)
	  
        self.top_entry = Entry()
        self.lab1 = Combo()
        self.__init_childrens( self.top_entry, self.lab1, self.txt_euro )
        
        self.bottom_entry = Entry()
        self.lab2 = Combo()
        self.__init_childrens( self.bottom_entry, self.lab2, self.txt_fr )

        self.calc.set_coef( self.txt_euro, self.txt_fr )
	  
        self.handler_euro = self.top_entry.connect( "changed", self.on_click_e2f )
        self.handler_fr = self.bottom_entry.connect( "changed", self.on_click_f2e )

    def __init_childrens( self, entry, combo, index ):                
        p1 = HBox()
        self.add( p1 )
        p1.show()
        
        entry.set_editable( TRUE )
        p1.pack_start( entry, expand = TRUE )
        entry.show()
        
        combo.set_popdown_strings( self.calc.taux.keys() )
        combo.get_children()[0].set_text( index ) #self.calc.taux.keys(index) )
        combo.get_children()[0].set_editable( FALSE )
        combo.set_size_request( 70,10 )
        combo.show()
        combo.get_children()[0].connect( "changed", self.on_swap_devise )
        p1.pack_start( combo )

    def on_swap_devise( self, but ):
        self.calc.set_coef( self.lab1.get_children()[0].get_text() ,
	   			self.lab2.get_children()[0].get_text())
        self.calc.set_1_to_2()
        self.txt_euro = self.lab1.get_children()[0].get_text()
        self.txt_fr = self.lab2.get_children()[0].get_text() 
        if but == self.lab1.get_children()[0]:
            self.on_click_f2e ( self.bottom_entry )
        else:
            self.on_click_e2f ( self.top_entry )

    def on_click_f2e( self, entry ):
        self.on_convert_dot( entry )
        try:
            self.top_entry.handler_block( self.handler_euro )
            self.calc.set_val( entry.get_text(), "2" )
            self.calc.set_2_to_1()
            self.top_entry.set_text( locale.format("%.2f", self.calc.value1 ) )
        except:
            self.top_entry.set_text( '' )
        self.top_entry.handler_unblock( self.handler_euro )

    def on_click_e2f( self, entry):
        self.on_convert_dot( entry )
        try:
            self.bottom_entry.handler_block( self.handler_fr )
            self.calc.set_val( entry.get_text(), "1" )
            self.calc.set_1_to_2();
            self.bottom_entry.set_text( locale.format( "%.2f", self.calc.value2 ))
        except:
            self.bottom_entry.set_text( '')
        self.bottom_entry.handler_unblock( self.handler_fr )

    def on_convert_dot( self, car ):
        if self.calc.dot != '.':
            if car.get_text().find( '.' ) > -1:
                car.set_text( car.get_text().replace( '.', self.calc.dot ))


class Geuro(Window):
    def __init__(self):
        Window.__init__( self )
        self.set_title( "geurocalc" )

        pix= gdk.pixbuf_new_from_xpm_data( geurocalc_xpm)
        self.set_icon( pix )

        box = VBox()
        self.add( box )
        box.show()

        self.calc_widget = EuroCalc()
        box.pack_start( self.calc_widget )
        self.calc_widget.show()

if __name__ == '__main__':
    import gtk
    import locale
    import os
    win = Geuro() 
    win.connect( 'destroy', mainquit )
    win.connect( 'delete_event', mainquit )
    win.set_size_request ( 210, 75 )
    win.set_uposition( gtk.gdk.screen_width() / 2 - 105, gtk.gdk.screen_height() / 2 - 37 )
    win.set_default_size( 210, 75 )
    # loading file
    win.show()
    mainloop()
    win.calc_widget.save_config()
    # try to save the last configuration
